new Promise(()=>{
 "use strict";

window.zenzaExt.zenzaExt5 = {
  addZenzaEvent() {
    var link = document.createElement('link');
    link.setAttribute('href', '/local/nlZenzaWatch-extension5.css');
    link.setAttribute('type', 'text/css');
    link.setAttribute('charset', 'utf-8');
    link.setAttribute('rel', 'stylesheet');
    document.body.appendChild(link);
    
    const element = document.getElementsByClassName('zenzaWatchVideoInfoPanel')[0];
    element.getElementsByClassName('tabSelectContainer')[0].insertAdjacentHTML("BeforeEnd", '<div class="tabSelect zwMediainfoTab" data-tab="zwMediainfo" onClick="window.zenzaExt.zenzaExt5.nl_itab_MI.call(window.zenzaExt.zenzaExt5);">MediaInfo</div>');
    
    element.getElementsByClassName('tabSelectContainer')[0].insertAdjacentHTML("AfterEnd", '<div class="tabs zwMediainfo"></div>');
    
    window.zenzaExt.removeVideoLoadEventListener([window.zenzaExt.zenzaExt5.addZenzaEvent]);
    window.zenzaExt.addVideoLoadEventListener([window.zenzaExt.zenzaExt5.addZenzaEvent2.bind(window.zenzaExt.zenzaExt5)]);
  },

  addZenzaEvent2() {
    this.oldSize = 0;
    this.Arr = [];
    this.data = {};
    this.smid = '';
    this.low = 0;
    this.isDmc = 0;
    this.dmcId = '';
    
    var E = document.getElementsByClassName('zwMediainfo')[0];
    E.innerHTML = '';
    if (E.classList.contains('activeTab')) {
      this.nl_itab_MI();
    }
  },
//------------------------------------------------  
  intervalTime: 1000, //キャッシュ中更新間隔(ミリ秒)
  cachingItems: 60, //キャッシュ中,予想完了時間に使う個数
  //予想完了時間は[intervalTime]と[cachingItems]で算出、デフォルトは直近60秒の平均で算出
  
  oldSize: 0,
  Arr: [],
  data: {},
  smid: '',
  low: 0,
  
  isDmc: 0,
  dmcId: '',
/*******************************************/
  nl_itab_MI() {
    this.smid = window.zenzaExt.smid;
    
    var
      E = document.getElementById('zenzaVideoPlayerDialog').getElementsByClassName('videoPlayer')[0].getAttribute('src');
    if (~E.indexOf('.nicovideo.jp/')) {
      this.isDmc = 0;
    } else if(~E.indexOf('.dmc.nico:')) {
      this.isDmc = 1;
    }
    window.zenzaExt.$XHR(`/cache/info/v2?${this.smid}`).then(this.CacheInfo.bind(this));
  },
/*******************************************/
  CacheInfo(aJson) {
    var json = JSON.parse(aJson.responseText)[this.smid];
    if (this.isDmc && json["preferredDmc"]) {
      this.dmcId = json["preferredDmc"];
    } else if (!this.isDmc && json["preferredSmile"]) {
      this.dmcId = json["preferredSmile"];
    } else if(!json["cachings"].length)  {
      document.getElementsByClassName('zwMediainfo')[0].textContent = 'キャッシュがありません';
      const $Func = () => {window.zenzaExt.$XHR(`/cache/info/v2?${this.smid}`).then(this.CacheInfo0.bind(this))};
      return setTimeout($Func.bind(this), 1000);
    }
    
    if (this.dmcId) {
      this.data[this.dmcId] = {};
      Promise
        .all([
          Promise.resolve(this.GetThumbinfo(this.smid)),
          Promise.resolve(this.CacheInfo2(json["caches"][this.dmcId])),
          window.zenzaExt.$XHR(`/cache/mediainfo?${this.dmcId}`, this.dmcId).then(this.GetMediainfo.bind(this)),
        ])
        .then(() => Promise.resolve(this.Write(this.dmcId)));
    }
    
    if (json["cachings"].length) {
      this.cachingId = json["cachings"][0];
      this.data[this.cachingId] = {};
      this.CachingsInfo(json);
    }
  },

/*******************************************/
  CachingsInfo(aJson) {
    const
      cachings = aJson["cachings"]
      ,completes = aJson["completes"];
    
    //console.log(`ingsInfo: ${this.cachingId}`);
    if (cachings.includes(this.cachingId)) {
      Promise
        .resolve(this.CacheInfo2(aJson["caches"][this.cachingId]))
        .then(() => Promise.resolve(this.cachingWrite(this.cachingId)));
      window.setTimeout(() => window.zenzaExt.$XHR(`/cache/info/v2?${this.smid}`).then((r) => this.CachingsInfo.call(this, JSON.parse(r.responseText)[this.smid])), this.intervalTime);
    } else {
      let
        id = this.cachingId.match(/([^\]]+\])[^.]+(\..+)/)
        ,completeId = this.dmcId
        ,Arr = [];
      
      if (id && completes.includes(`${id[1]}${id[2]}`)) {
        completeId = `${id[1]}${id[2]}`;
        this.data[completeId] = {};
        Arr.push(Promise.resolve(this.CacheInfo2(aJson["caches"][completeId])));
      }
      if (!this.data.TI_video_id) Arr.push(Promise.resolve(this.GetThumbinfo(this.smid)));
      Arr.push(window.zenzaExt.$XHR(`/cache/mediainfo?${completeId}`, completeId).then(this.GetMediainfo.bind(this)));
      
      Promise
        .all(Arr)
        .then(() => Promise.resolve(this.Write(completeId)));
    }
  },
/*******************************************/
  cachingWrite(aCacheId) {
    //console.log(`ingW_${aCacheId}`);
    const
      DATA = this.data
      ,CacheDATA = this.data[aCacheId]
      ,cachingSize = CacheDATA["cachingSize"]
      ,size = CacheDATA["size"]
      ,oldSize = this.oldSize
      ,Arr = this.Arr
      ,TIME = () => {
       if (!this.Arr.length) return '';
       const _TIME = ((size -cachingSize) /(this.ave(this.Arr) /(this.intervalTime /1000))) |0
       if (_TIME > 60) {
         return ` 予想完了時間${(_TIME /60) |0}分${_TIME %60}秒)`;
       } else {
         return ` 予想完了時間${_TIME}秒)`;
       }
      }
      ,cachingText1 = (
        ` ${(cachingSize *100 /size)|0}% ` +
        `([${((cachingSize -oldSize) /1024)|0} Kbps]` +
        ` ${this.str(cachingSize,'K')} / ${this.str(size,'K')}`
      )
      ,cachingText2 = `キャッシュ中です... ${cachingText1} ダウンロード${TIME()}`;
    
    let E = document.getElementById('MIcachingInfo');
    if (!E) {
      document.getElementsByClassName('zwMediainfo')[0]
        .insertAdjacentHTML("BeforeEnd", `<div id="MIcachingInfo" stye="margin-top:2em;">${cachingText2}</div>`);
    } else {
      E.textContent = `${cachingText2}`;
    }
    
    if (oldSize) {
      Arr.unshift(cachingSize -oldSize);
      this.Arr = Arr.slice(0, this.cachingItems);
    }
    this.oldSize = cachingSize;
  },
/*******************************************/
  CacheInfo2(aJson) {
    const
      {
        videoId,
        cacheId,
        complete,
        economy,
        dmc,
        dmcMovieType,
        caching,
        movieType,
        size,
        cachingSize,
        title,
        subFolder,
        filename,
        ts,
        reEncoded,
      } = aJson
      ,DATA = this.data[cacheId];
    
    //console.log(`CI2_${cacheId}`);
    DATA.cacheType  = economy? '[low]': '';
    DATA.cacheTitle = title;
    DATA.subFolder  = subFolder? subFolder: '';
    DATA.ts         = ts? this.dateChange(ts): '';
    DATA.reEncoded  = reEncoded;
    DATA.caching    = caching;
    DATA.cachingSize= cachingSize;
    DATA.size       = size;
    
    if (dmc) {
      DATA.dmc             = dmc;
      DATA.dmcVideoMode    = dmcMovieType["videoMode"];
      DATA.dmcVideoBitrate = dmcMovieType["videoBitrate"];
      DATA.dmcAudioBitrate = dmcMovieType["audioBitrate"];
    }
  },
/*******************************************/
  GetThumbinfo(aSmid) {
    //console.log(`GTi_${aSmid}`);
    const
      DATA = this.data
      ,$F = xml => {
        xml = new DOMParser().parseFromString(xml, 'application/xml');
        
        const
          DATA = window.zenzaExt.zenzaExt5.data
          ,selector = ['video_id', 'movie_type', 'length'];
        selector.forEach(S => DATA[`TI_${S}`] = xml.getElementsByTagName(S)[0].textContent);
        
        const
          size_high = xml.getElementsByTagName('size_high')[0].textContent -0
          ,size_low  = xml.getElementsByTagName('size_low')[0].textContent -0;
        DATA.TI_size_high = size_high > 0? this.str(size_high,'M'): 'None';
        DATA.TI_size_low  = size_low  > 0? this.str(size_low ,'M'): 'None';
      };
    var  d;
    
    if ((d = window.popThumb.data[`obj_${aSmid}`]) && (d = d[1]).usingAPI.getthumbinfo) {
      DATA.TI_video_id   = d.video_id;
      DATA.TI_movie_type = d.movie_type;
      DATA.TI_length     = d.length;
      DATA.TI_size_high  = d.size_high > 0? this.str(d.size_high,'M'): 'None';
      DATA.TI_size_low   = d.size_low  > 0? this.str(d.size_low ,'M'): 'None';
    }else{
      window.popThumb.HttpRequest(`/pr_Redirect_ext.nicovideo.jp/api/getthumbinfo/${aSmid}`, $F, true, aSmid, ['api', aSmid])
    }
  },
/*******************************************/
  GetMediainfo([aXml, aCacheId]) {
    //console.log(`GMi_${aCacheId}`);
    const 
      xml = new DOMParser().parseFromString(aXml.responseText, 'application/xml')
      ,SELECTOR = {
        General:['Format', 'Format_profile', 'Overall_bit_rate', 'File_size'],
        Video:['Format', 'Format_profile', 'Bit_rate_mode', 'Bit_rate', 'Frame_rate', 'Stream_size'],
        Audio:['Format', 'Format_profile', 'Bit_rate_mode', 'Bit_rate', 'Channel_s_', 'Sampling_rate', 'Stream_size'],
      }
      ,DATA = this.data[aCacheId];
    var s;
    for (let x in SELECTOR) {
      for (let S of SELECTOR[x]) {
        if (!(s = this.qSele(xml, x, S))) {
          DATA[`MI_${x}_${S}`] = '';
          continue;
        }
        switch (S) {
          case 'File_size':
            s = s.textContent.replace(/(\.\d)\d/g, '$1');
            break;
          case 'Overall_bit_rate':
            s = s.textContent.replace(/ (?=\d)/g, ',');
            break;
          case 'Bit_rate_mode':
            s = '(' + s.textContent + ')';
            break;
          case 'Bit_rate':
            s = s.textContent.replace(/ (?!K)/g, ',').replace(/\.\d/g, '');
            break;
          case 'Stream_size':
            let R = s.textContent.replace(/(\.\d)\d/g, '$1').match(/^(.+B) (.+)$/);
            s=R[1];
            DATA[`MI_${x}_${S}_percent`] = R[2];
            break;
          default:
            s = s.textContent;
            break;
        }
        DATA[`MI_${x}_${S}`] = s;
      }
    }
    
    var
      MI_Video_Width = this.qSele(xml, 'Video', 'Width')
      ,MI_Video_Height = this.qSele(xml, 'Video', 'Height');
    if (MI_Video_Width && MI_Video_Height) {
      let
        width = MI_Video_Width.textContent.slice(0, -7).replace(' ', ',')
        ,height = MI_Video_Height.textContent.slice(0, -7).replace(' ', ',');
      DATA.MI_Resolution = (`${width} x ${height}`);
    }
  },
/*******************************************/
  Write(aCacheId) {
    //console.log(`W_${aCacheId}`);
    const
      DATA = this.data
      ,CacheDATA = this.data[aCacheId];
    
    document.getElementsByClassName('zwMediainfo')[0].innerHTML = (
      '<div id="zwMediainfoTable">'+
//------------------------------------------------
        '<div class="zw_TitleT">タイトル</div>'+
        '<div class="zw_MIsep1-1">:</div>'+
        `<div class="zw_Title"><span id="cacheType">${CacheDATA.cacheType}</span> <span id="cacheTitle">${CacheDATA.cacheTitle}</span></div>`+
//------------------------------------------------
        '<div class="zw_InfoT">動画情報</div>'+
        '<div class="zw_MIsep2-1">:</div>'+
        `<div class="zw_vId"><span id="TI_video_id">${DATA.TI_video_id}</span></div>`+
        '<div class="zw_MIsep2-2">/</div>'+
        `<div class="zw_mType"><span id="TI_movie_type">` + (CacheDATA.dmc? `[${CacheDATA.dmcVideoMode},${CacheDATA.dmcVideoBitrate},${CacheDATA.dmcAudioBitrate}].`: '') + `${DATA.TI_movie_type}</span></div>`+
        '<div class="zw_MIsep2-3">/</div>'+
        `<div class="zw_sizeH"><span id="TI_size_high">${DATA.TI_size_high}</span></div>`+
        '<div class="zw_MIsep2-4">/</div>'+
        `<div class="zw_sizeL">Economy:<span id="TI_size_low">${DATA.TI_size_low}</span></div>`+
//------------------------------------------------
        '<div class="zw_FormatT">形　式</div>'+
        '<div class="zw_MIsep3-1">:</div>'+
        `<div class="zw_Format"><span id="MI_General_Format">${CacheDATA.MI_General_Format}</span><span id="MI_General_Format_profile">${CacheDATA.MI_General_Format_profile}</span></div>`+
        '<div class="zw_MIsep3-2">/</div>'+
        `<div class="zw_bitRate"><span id="MI_General_Overall_bit_rate">${CacheDATA.MI_General_Overall_bit_rate}</span></div>`+
        '<div class="zw_MIsep3-3">/</div>'+
        `<div class="zw_fileSize"><span id="MI_General_File_size">${CacheDATA.MI_General_File_size}</span></div>`+
        '<div class="zw_MIsep3-4">/</div>'+
        `<div class="zw_Length"><span id="TI_length">${DATA.TI_length}</span></div>`+
//------------------------------------------------
        '<div class="zw_VideoT">映　像</div>'+
        '<div class="zw_MIsep4-1">:</div>'+
        `<div class="zw_vFormat"><span id="MI_Video_Format">${CacheDATA.MI_Video_Format}</span> <span id="MI_Video_Format_profile">${CacheDATA.MI_Video_Format_profile}</span></div>`+
        '<div class="zw_MIsep4-2">/</div>'+
        '<div class="zw_vBitRateC">'+
          `<span class="zw_vBitRate"><span id="MI_Video_Bit_rate">${CacheDATA.MI_Video_Bit_rate}</span></span>`+
          `<span class="zw_vBitRateM zw_paddingL"><span id="MI_Video_Bit_rate_mode">${CacheDATA.MI_Video_Bit_rate_mode}</span></span>`+
        '</div>'+
        '<div class="zw_MIsep4-3">/</div>'+
        '<div class="zw_vStreamSizeC">'+
          `<span class="zw_vStreamSize"><span id="MI_Video_Stream_size">${CacheDATA.MI_Video_Stream_size}</span></span>`+
          `<span class="zw_vStreamSizeP zw_paddingL"><span id="MI_Video_Stream_size_percent">${CacheDATA.MI_Video_Stream_size_percent}</span></span>`+
        '</div>'+
        '<div class="zw_MIsep4-4">/</div>'+
        `<div class="zw_Resolution"><span id="MI_Resolution">${CacheDATA.MI_Resolution}</span> <span id="MI_Video_Frame_rate" style="white-space:nowrap;">@ ${CacheDATA.MI_Video_Frame_rate}</span></div>`+
//------------------------------------------------
        '<div class="zw_AudioT">音　声</div>'+
        '<div class="zw_MIsep5-1">:</div>'+
        `<div class="zw_aFormat"><span id="MI_Audio_Format">${CacheDATA.MI_Audio_Format}</span> <span id="MI_Audio_Format_profile">${CacheDATA.MI_Audio_Format_profile}</span></div>`+
        '<div class="zw_MIsep5-2">/</div>'+
        '<div class="zw_aBitRateC">'+
          `<span class="zw_aBitRate"><span id="MI_Audio_Bit_rate">${CacheDATA.MI_Audio_Bit_rate}</span></span>`+
          `<span class="zw_aBitRateM zw_paddingL"><span id="MI_Audio_Bit_rate_mode">${CacheDATA.MI_Audio_Bit_rate_mode}</span></span>`+
        '</div>'+
        '<div class="zw_MIsep5-3">/</div>'+
        '<div class="zw_aStreamSizeC">'+
          `<span class="zw_aStreamSize"><span id="MI_Audio_Stream_size">${CacheDATA.MI_Audio_Stream_size}</span></span>`+
          `<span class="zw_aStreamSizeP zw_paddingL"><span id="MI_Audio_Stream_size_percent">${CacheDATA.MI_Audio_Stream_size_percent}</span></span>`+
        '</div>'+
        '<div class="zw_MIsep5-4">/</div>'+
        `<div class="zw_aSamplingRate"><span id="MI_Audio_Sampling_rate">${CacheDATA.MI_Audio_Sampling_rate}</span> <span id="MI_Audio_Channel_s_" style="white-space:nowrap;">@ ${CacheDATA.MI_Audio_Channel_s_}</span></div>`+
//------------------------------------------------
        '<div class="zw_TimestampT">ﾀｲﾑｽﾀﾝﾌﾟ</div>'+
        '<div class="zw_MIsep6-1">:</div>'+
        `<div class="zw_ts"><span id="MI_ts">${CacheDATA.ts}</span></div>`+
//        '<div class="zw_MIsep6-2">|</div>'+
        (CacheDATA.reEncoded !== undefined?
          '<div class="zw_reEncodedT">reEnc</div>'+
          '<div class="zw_MIsep6-2">:</div>'+
          `<div class="zw_reE"><span id="MI_reE">${CacheDATA.reEncoded}</span></div>`
          : '<div class="zw_MIcollapse6-2"></div>'
        )+
        `<div class="zw_FolderT">フォルダ</div>`+
        '<div class="zw_MIsep6-3">:</div>'+
        `<div class="zw_Folder"><span id="MI_subFolder">${CacheDATA.subFolder}</span></div>`+
    '</div>');
  },
/*******************************************/
  ave(aArray) {
    const SUM = aArray.reduce((previousValue, currentValue, index, array) => previousValue + currentValue);
    return (SUM /aArray.length) |0;
  },

  qSele(aXml, aType, aTag) {
    return aXml.querySelector(`track[type="${aType}"] > ${aTag}`);
  },

  str(V, aUnit) {
    var U = (aUnit === 'K')? 1024:
            (aUnit === 'M')? (1024 *1024): 1;
    V = ((V /U).toLocaleString()) +'';
    U = V.indexOf('.');
    return `${!~U? V: V.slice(0, U)} ${aUnit}iB`;
  },

  dateChange(aDate) {
    const
      dates = ((new Date(aDate *1000)).toISOString()).split('T')
      ,[year, month, date] = dates[0].split('-')
      ,[hour, minute, second] = (dates[1].split('.'))[0].split(':');
    return `${year}年${month}月${date}日${hour}時${minute}分${second}秒`;
  },
};

window.zenzaExt.addVideoLoadEventListener([window.zenzaExt.zenzaExt5.addZenzaEvent]);
});